Module SQL_跨介面共用
    Friend Sub SQL_FTP資料夾路徑分配()
        ConnOpen() : SQL1 = "SELECT 資料夾名稱, 指定頁面, 備註, 指定 FROM FTP資料夾管理" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_系統版本號驗證()
        ConnOpen() : SQL1 = "SELECT 系統認證版本號 FROM 版本號管理 " : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_圖片顯示()
        ConnOpen() : SQL1 = "SELECT 圖片 FROM 物料資料庫 WHERE 料號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料檔案_是否有圖()
        ConnOpen() : SQL1 = "SELECT  是否有圖 FROM 物料資料庫 WHERE (料號 LIKE N'" & PA1 & "%')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_地區碼_下拉清單()
        ConnOpen() : SQL1 = "SELECT 地區, 編碼 FROM 地區碼 ORDER BY 編碼" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_指定倉儲_資料讀取()
        ConnOpen() : SQL1 = "SELECT 倉級, 倉名編號 FROM 倉儲分區控制表 WHERE (倉名 LIKE N'" & PA6 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_訂製狀態_下拉清單_有條件()
        ConnOpen()
        SQL1 = "SELECT     物料訂製狀態.訂製, 物料訂製狀態.編碼
                FROM       物料訂製狀態 INNER JOIN
                           倉儲明細表 ON 物料訂製狀態.編碼 = 倉儲明細表.訂製狀態
                WHERE     (倉儲明細表.料號 LIKE '" & PA20 & "') AND (倉儲明細表.審核人 NOT LIKE '作廢%')
                GROUP BY   物料訂製狀態.訂製, 物料訂製狀態.編碼
                ORDER BY   物料訂製狀態.訂製, 物料訂製狀態.編碼"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_訂製狀態_下拉清單()
        ConnOpen() : SQL1 = "SELECT 訂製, 編碼 FROM 物料訂製狀態 ORDER BY 訂製, 編碼" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲狀態_下拉清單_有條件()
        ConnOpen()
        SQL1 = "SELECT     倉儲狀態.狀態, 倉儲狀態.編碼
                FROM       倉儲狀態 RIGHT OUTER JOIN 倉儲明細表 ON 倉儲狀態.編碼 = 倉儲明細表.物料狀態
                WHERE     (倉儲明細表.料號 LIKE '" & PA20 & "') AND (倉儲明細表.審核人 NOT LIKE '作廢%')
                GROUP BY   倉儲狀態.狀態, 倉儲狀態.編碼
                ORDER BY   倉儲狀態.狀態, 倉儲狀態.編碼"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲狀態_下拉清單()
        ConnOpen() : SQL1 = "SELECT 狀態, 編碼 FROM 倉儲狀態 ORDER BY 狀態, 編碼" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_業務編號_下拉清單()
        ConnOpen() : SQL1 = "SELECT 業務號 FROM 業務編號 ORDER BY 業務號" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_狀態_下拉清單()
        ConnOpen() : SQL1 = "SELECT 狀態 FROM 倉儲明細表 GROUP BY 狀態" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲明細執行單號_執行單號驗證()
        ConnOpen() : SQL1 = "SELECT 執行單號 FROM 倉儲明細執行單號 WHERE (執行單號 LIKE N'" & PA1 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲明細執行單號_新增()
        ConnOpen() : SQL1 = "INSERT INTO 倉儲明細執行單號 (執行單號) VALUES (N'" & PA1 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲明細表_確認單據是否申請()
        ConnOpen() : SQL1 = "SELECT 料號 FROM 倉儲明細表 WHERE 執行單號 LIKE N'" & PA1 & "' AND 料號 LIKE N'" & PA2 & "' AND 倉名編號 LIKE '" & PA3 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲明細表_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 資料流水號 FROM 倉儲明細表 ORDER BY 資料流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 資料流水號 FROM 採購控制表 ORDER BY 資料流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購外埔表_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 流水號 FROM 採購外埔表 ORDER BY 流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購外埔表_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 採購外埔表 (銷售單號, 廠商編碼, 備註內容, 金額, 過帳日期, 流水號) 
                VALUES (N'" & PA36 & "', N'" & PA35 & "', N'" & PA34 & "', N'" & PA33 & "', N'" & PA32 & "', N'" & PA31 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購外埔表_修改()
        ConnOpen() : SQL1 = "UPDATE 採購外埔表 SET 備註內容 = N'" & PA34 & "', 金額 = N'" & PA33 & "' WHERE 流水號 LIKE N'" & PA35 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購外埔表_過帳()
        ConnOpen() : SQL1 = "UPDATE 採購外埔表 SET 過帳日期 = N'" & PA32 & "' WHERE 流水號 LIKE N'" & PA35 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購外埔表_刪除()
        ConnOpen() : SQL1 = "DELETE 採購外埔表 WHERE 流水號 LIKE N'" & PA35 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲明細表_出入庫及修改()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 入庫 = N'" & NU1 & "', 出庫 = N'" & NU2 & "', 備註 = N'" & PA10 & "' WHERE (資料流水號 LIKE N'" & PA11 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲明細表_刪除二()
        ConnOpen() : SQL1 = "DELETE FROM 倉儲明細表 WHERE (資料流水號 LIKE N'" & PA1 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲明細執行單號_刪除()
        ConnOpen() : SQL1 = "DELETE FROM 倉儲明細執行單號 WHERE (執行單號 LIKE N'" & PA1 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲明細表_刪除()
        ConnOpen() : SQL1 = "DELETE FROM 倉儲明細表 WHERE (執行單號 LIKE N'" & PA1 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉名_下拉清單()
        ConnOpen() : SQL1 = "SELECT 倉名 FROM 倉儲分區控制表 ORDER BY 倉名" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉名_下拉清單_有條件()
        ConnOpen()
        SQL1 = "SELECT 倉儲分區控制表.倉名 
                FROM 倉儲明細表 INNER JOIN 倉儲分區控制表 ON 倉儲明細表.倉名編號 = 倉儲分區控制表.倉名編號 
                WHERE (倉儲明細表.料號 LIKE '" & PA20 & "') AND (倉儲明細表.審核人 NOT LIKE '作廢%')
        GROUP BY   倉儲分區控制表.倉名
        ORDER BY   倉儲分區控制表.倉名"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉名_物料分配查詢()
        ConnOpen()
        SQL1 = "SELECT    倉儲分區控制表.倉名, ISNULL(SUM(倉儲明細表.入庫 - 倉儲明細表.出庫), 0) AS 可用
                FROM      倉儲明細表 INNER JOIN 倉儲分區控制表 ON 倉儲明細表.倉名編號 = 倉儲分區控制表.倉名編號
                WHERE    (倉儲明細表.料號 LIKE '" & PA20 & "') AND (倉儲明細表.審核人 NOT LIKE '作廢%')
                GROUP BY   倉儲分區控制表.倉名
                ORDER BY   倉儲分區控制表.倉名"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_盤盈盤損申請_物料清單()
        ConnOpen()
        If PA1 = "" Then
            If PA2 = "" Then
                SQL2 = ""
            Else
                SQL2 = " WHERE (供應商資料表.編號 LIKE '" & PA2 & "')"
            End If
        Else
            If PA2 = "" Then
                SQL2 = " WHERE (物料資料庫.料號 LIKE N'" & PA & "%' OR 物料資料庫.品名 LIKE N'%" & PA & "%')"
            Else
                SQL2 = " WHERE (供應商資料表.編號 LIKE '" & PA2 & "') AND (物料資料庫.料號 LIKE N'" & PA & "%' OR 物料資料庫.品名 LIKE N'%" & PA & "%')"
            End If
        End If
        SQL1 = "SELECT     物料資料庫.料號, 供應商資料表.簡稱 AS 供應商, 物料資料庫.品名, BB.庫存, AA.未出庫, 
                           物料資料庫.是否有圖 AS 圖片, 物料資料庫.最低庫存量
                FROM       物料資料庫 INNER JOIN
                           供應商資料表 ON 物料資料庫.供應商編號 = 供應商資料表.編號 LEFT OUTER JOIN
                          (SELECT          料號, SUM(入庫 - 出庫) AS 未出庫
                           FROM               倉儲明細表
                           WHERE           (審核人 NOT LIKE '作廢%') AND (倉庫作業 LIKE '')
                           GROUP BY    料號) AS AA ON 物料資料庫.料號 = AA.料號 LEFT OUTER JOIN
                          (SELECT          料號, SUM(入庫 - 出庫) AS 庫存
                           FROM               倉儲明細表 AS 倉儲明細表_1
                           WHERE           (審核人 NOT LIKE '作廢%')
                           GROUP BY    料號) AS BB ON 物料資料庫.料號 = BB.料號
                           " & SQL2 & "
                ORDER BY   物料資料庫.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_盤盈盤損申請_供應商_下拉清單()
        ConnOpen()
        If PA3 = "" Then
            SQL1 = "SELECT 編號, 簡稱 FROM   供應商資料表 WHERE 停用 = 0 ORDER BY   編號"
        ElseIf PA3 = "1" Or PA3 = "2" Or PA3 = "9" Or PA3 = "Y" Then
            SQL1 = "SELECT 編號, 簡稱 FROM   供應商資料表
                    WHERE  (編號 LIKE N'" & PA3 & "%') AND (停用 = 0)
                    ORDER BY   編號"
        ElseIf PA3 = "3" Then
            SQL1 = "SELECT  編號, 簡稱 FROM   供應商資料表
                    WHERE  (編號 NOT LIKE N'2%')  AND (編號 NOT LIKE N'9%')  AND (編號 NOT LIKE N'Y%')  AND (停用 = 0)  ORDER BY   編號"
        End If
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客戶資料表_流水號_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 流水號 FROM 客戶資料表 ORDER BY 流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客戶資料表_編號_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 舊編 FROM 客戶資料表 WHERE (舊編 LIKE N'" & PA18 & "%') ORDER BY 舊編 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客戶資料表_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 客戶資料表 (流水號, 舊編, 名稱, 電話1, 電話2, 地址, 公司名稱, 統編) 
                VALUES (N'" & PA16 & "', N'" & PA17 & "', N'', N'', N'', N'', N'', N'')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客戶資料表_修改()
        ConnOpen()
        SQL1 = "UPDATE 客戶資料表 SET 名稱 = N'" & PA14 & "', 電話1 = N'" & PA13 & "', 電話2 = N'" & PA12 & "', 地址 = N'" & PA11 & "', 公司名稱 = N'" & PA10 & "', 統編 = N'" & PA9 & "' 
                WHERE (流水號 = N'" & PA8 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_客戶資料表_刪除()
        ConnOpen() : SQL1 = "DELETE 客戶資料表 WHERE (流水號 = N'" & 客戶資料表.流水號_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細表_修改()
        ConnOpen() : SQL1 = "UPDATE 採購控制表 SET 銷售流水 = '' WHERE (銷售單號 LIKE '') AND (銷售流水 NOT LIKE '')" : CmdSet_For_dr()
        ConnOpen()
        SQL1 = "UPDATE 銷售明細表 SET 備註 = N'" & PA10 & "', 成本 = N'" & NU1 & "', 售價 = N'" & NU2 & "', 含稅 = N'" & BL5 & "',倉儲狀態 = N'" & PA9 & "', 
                                      物料狀態 = N'" & PA8 & "', 訂製狀態 = N'" & PA7 & "', 不含管銷 = N'" & BL6 & "' 
                WHERE (資料流水號 LIKE N'" & PA11 & "')"
        CmdSet_For_dr()
        ConnOpen()
        SQL1 = "UPDATE 採購控制表 SET 物料狀態 = N'" & PA8 & "', 訂製狀態 = N'" & PA7 & "', 倉儲狀態 = N'" & PA9 & "', 備註 = N'" & PA10 & "', 成本 = '" & NU1 & "'
                WHERE  銷售流水 LIKE '" & PA11 & "%'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細表_成本讀取()
        ConnOpen()
        SQL1 = "SELECT 成本 FROM 物料資料庫 WHERE 料號 LIKE '" & PA12 & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售備註表_修改()
        ConnOpen()
        SQL1 = "UPDATE 銷售備註表 SET 備註 = N'" & PA10 & "', 收入 = N'" & NU1 & "', 支出 = N'" & NU2 & "' WHERE (資料流水號 LIKE N'" & PA11 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售衍生運費_修改()
        ConnOpen()
        SQL1 = "UPDATE 銷售衍生運費 SET 運費備註 = N'" & PA10 & "', 支出 = N'" & NU1 & "' WHERE (資料流水號 LIKE N'" & PA11 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售收款事項_修改()
        ConnOpen()
        SQL1 = "UPDATE 銷售收款事項 SET 內容 = N'" & PA10 & "', 金額 = N'" & NU1 & "', 含稅 = N'" & PA12 & "' WHERE (資料流水號 LIKE N'" & PA11 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售收款事項()
        ConnOpen()
        SQL1 = "SELECT 資料流水號, 單號, 項次 AS 真項次, 項次, 內容, 金額, 收支單號, 轉財務, 含稅  FROM 銷售收款事項 WHERE (單號 LIKE '" & PA2 & "') ORDER BY 項次 DESC, 內容 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_銷售控制表_刪除()
        ConnOpen() : SQL1 = "DELETE 銷售控制表 WHERE 單號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細表_整體刪除()
        ConnOpen() : SQL1 = "DELETE 銷售明細表 WHERE 單號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售備註表_整體刪除()
        ConnOpen() : SQL1 = "DELETE 銷售備註表 WHERE 單號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲控制表_依銷售單號刪除()
        ConnOpen() : SQL1 = "DELETE 倉儲明細表 WHERE 採購單號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售收款事項_整體刪除()
        ConnOpen() : SQL1 = "DELETE 銷售收款事項 WHERE 單號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細表_單筆刪除()
        ConnOpen() : SQL1 = "DELETE 銷售明細表 WHERE 資料流水號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲控制表_依銷售單號單筆刪除()
        ConnOpen() : SQL1 = "DELETE 倉儲明細表 WHERE 資料流水號 LIKE '" & PA1 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售單申請_客戶資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 名稱, 電話1, 電話2, 地址, 公司名稱, 統編 FROM 客戶資料表 WHERE 舊編 LIKE '" & PA15 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售單申請_客戶資料驗證()
        ConnOpen() : SQL1 = "SELECT 舊編, 名稱, 電話1, 電話2, 地址, 公司名稱, 統編 FROM 客戶資料表 WHERE 名稱 LIKE '%" & PA16 & "%'" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_銷售控制表_修改()
        ConnOpen()
        SQL1 = "UPDATE 銷售控制表 SET 單號 = N'" & PA2 & "', 開單日期 = N'" & DTP & "', 客戶編號 = N'" & PA3 & "', 交貨日期 = '" & DTP1 & "', 含稅 = '" & BL1 & "', 送貨地點 = N'" & PA5 & "', 
                       運費 = N'" & NU1 & "', 管銷費用 = N'" & NU2 & "' , 稅金 = N'" & NU3 & "', 刷卡費用 = N'" & NU4 & "', 銷貨總額 = N'" & NU5 & "' " & SQL5 & "
                WHERE 流水號 LIKE '" & PA1 & "%'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷貨總額_修改()
        ConnOpen() : SQL1 = "UPDATE 銷售控制表 SET 銷貨總額 = N'" & NU5 & "' WHERE 流水號 LIKE '" & PA1 & "%'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售單申請_銷售明細表_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 銷售明細表 (資料流水號, 單號, 料號, 物料狀態, 訂製狀態, 備註, 數量, 成本, 售價, 狀態, 含稅, 倉儲狀態, 排序, 不含管銷) 
                VALUES (N'" & PA3 & "',N'" & PA4 & "',N'" & PA2 & "',N'" & PA7 & "',N'" & PA8 & "', N'', N'" & NU1 & "', N'" & NU2 & "', N'" & NU3 & "', 
                         '" & PA9 & "', N'" & BL2 & "', N'" & PA10 & "', N'" & PA11 & "', '0')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售單申請_倉儲明細表_銷售出庫()
        ConnOpen()
        SQL1 = "INSERT INTO 倉儲明細表 (資料流水號, 執行單號, 倉級, 倉名編號, 料號, 入庫, 出庫, 備註, 狀態, 採購單號, 申請人, 申請日期, 審核人, 審核日期, 倉庫作業, 作業日期, 物料狀態, 訂製狀態) 
                VALUES (N'" & PA3 & "',N'" & PA4 & "',N'" & PA5 & "',N'" & PA6 & "',N'" & PA2 & "', N'0',N'" & NU1 & "', N'', N'銷售出庫', N'" & PA9 & "', N'" & gUserName & "', N'" & DTP & "', 
                        N'', N'', N'', N'', N'" & PA7 & "', N'" & PA8 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細表()
        ConnOpen()
        SQL1 = "SELECT      銷售明細表.資料流水號, 銷售明細表.資料流水號 AS 項次, 銷售明細表.料號, 物料資料庫.品名, 倉儲分區控制表.倉名, 
                            物料訂製狀態.訂製, 倉儲狀態.狀態, 銷售明細表.備註, 銷售明細表.數量, 銷售明細表.成本, 銷售明細表.售價 AS 單價, 
                            銷售明細表.含稅, 銷售明細表.售價, 銷售明細表.狀態 AS 倉儲情況, 銷售明細表.資料流水號 AS 倉儲流水號, 銷售明細表.倉儲狀態, 銷售明細表.訂製狀態, 
                            銷售明細表.物料狀態, 銷售明細表.不含管銷 AS 無管銷
                FROM        銷售明細表 INNER JOIN
                            倉儲狀態 ON 銷售明細表.物料狀態 = 倉儲狀態.編碼 INNER JOIN
                            倉儲分區控制表 ON 銷售明細表.倉儲狀態 = 倉儲分區控制表.倉名編號 LEFT OUTER JOIN
                            採購控制表 ON 銷售明細表.料號 = 採購控制表.料號 AND 
                            銷售明細表.資料流水號 = 採購控制表.銷售流水 LEFT OUTER JOIN
                            物料訂製狀態 ON 銷售明細表.訂製狀態 = 物料訂製狀態.編碼 LEFT OUTER JOIN
                            物料資料庫 ON 銷售明細表.料號 = 物料資料庫.料號
                WHERE      (銷售明細表.單號 LIKE '" & PA2 & "')
                ORDER BY    銷售明細表.排序 DESC, 銷售明細表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_銷售明細表_轉採購_一般用()
        ConnOpen()
        SQL1 = "SELECT      銷售明細表.單號, 銷售明細表.資料流水號, 銷售明細表.資料流水號 AS 項次, 銷售明細表.料號, 物料資料庫.品名, 
                            倉儲分區控制表.倉名, 物料訂製狀態.訂製, 倉儲狀態.狀態, 銷售明細表.備註, 銷售明細表.數量, 銷售明細表.成本, 
                            銷售明細表.售價 AS 單價, 銷售明細表.含稅, 銷售明細表.售價 AS 金額, 銷售明細表.狀態 AS 倉儲情況, 
                            銷售明細表.資料流水號 AS 倉儲流水號, 
                            銷售明細表.倉儲狀態, 銷售明細表.訂製狀態,銷售明細表.物料狀態
                FROM        銷售明細表 INNER JOIN
                            倉儲狀態 ON 銷售明細表.物料狀態 = 倉儲狀態.編碼 INNER JOIN
                            倉儲分區控制表 ON 銷售明細表.倉儲狀態 = 倉儲分區控制表.倉名編號 LEFT OUTER JOIN
                            倉儲明細表 ON 銷售明細表.料號 = 倉儲明細表.料號 AND 銷售明細表.單號 = 倉儲明細表.採購單號 LEFT OUTER JOIN
                            物料訂製狀態 ON 銷售明細表.訂製狀態 = 物料訂製狀態.編碼 LEFT OUTER JOIN
                            物料資料庫 ON 銷售明細表.料號 = 物料資料庫.料號
                WHERE      (銷售明細表.單號 LIKE '" & PA2 & "%') AND (銷售明細表.料號 NOT LIKE '1%') AND (銷售明細表.已出貨 <> 1) AND 
                           (銷售明細表.料號 NOT LIKE 'Y199999')
                GROUP BY    銷售明細表.資料流水號, 銷售明細表.資料流水號, 銷售明細表.料號, 物料資料庫.品名, 倉儲分區控制表.倉名, 
                            物料訂製狀態.訂製, 倉儲狀態.狀態, 銷售明細表.備註, 銷售明細表.數量, 銷售明細表.成本, 銷售明細表.售價, 
                            銷售明細表.含稅, 銷售明細表.售價, 銷售明細表.狀態, 銷售明細表.資料流水號, 銷售明細表.倉儲狀態, 
                            銷售明細表.訂製狀態, 銷售明細表.物料狀態, 銷售明細表.單號
                ORDER BY    銷售明細表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_銷售明細表_轉採購()
        ConnOpen()
        SQL1 = "SELECT      銷售明細表.資料流水號, 銷售明細表.資料流水號 AS 項次, 銷售明細表.料號, 物料資料庫.品名, 倉儲分區控制表.倉名, 
                            物料訂製狀態.訂製, 倉儲狀態.狀態, 銷售明細表.備註, 銷售明細表.數量, 銷售明細表.成本, 銷售明細表.售價 AS 單價, 
                            銷售明細表.含稅, 銷售明細表.售價 AS 金額, 銷售明細表.狀態 AS 倉儲情況, 銷售明細表.資料流水號 AS 倉儲流水號, 
                            銷售明細表.倉儲狀態, 銷售明細表.訂製狀態,銷售明細表.物料狀態
                FROM        銷售明細表 INNER JOIN
                            倉儲狀態 ON 銷售明細表.物料狀態 = 倉儲狀態.編碼 INNER JOIN
                            倉儲分區控制表 ON 銷售明細表.倉儲狀態 = 倉儲分區控制表.倉名編號 LEFT OUTER JOIN
                            倉儲明細表 ON 銷售明細表.料號 = 倉儲明細表.料號 AND 銷售明細表.單號 = 倉儲明細表.採購單號 LEFT OUTER JOIN
                            物料訂製狀態 ON 銷售明細表.訂製狀態 = 物料訂製狀態.編碼 LEFT OUTER JOIN
                            物料資料庫 ON 銷售明細表.料號 = 物料資料庫.料號
                WHERE      (銷售明細表.單號 LIKE '" & PA2 & "') AND (銷售明細表.料號 NOT LIKE '1001%')
                GROUP BY    銷售明細表.資料流水號, 銷售明細表.資料流水號, 銷售明細表.料號, 物料資料庫.品名, 倉儲分區控制表.倉名, 
                            物料訂製狀態.訂製, 倉儲狀態.狀態, 銷售明細表.備註, 銷售明細表.數量, 銷售明細表.成本, 銷售明細表.售價, 
                            銷售明細表.含稅, 銷售明細表.售價, 銷售明細表.狀態, 銷售明細表.資料流水號, 銷售明細表.倉儲狀態, 
                            銷售明細表.訂製狀態, 銷售明細表.物料狀態
                ORDER BY   銷售明細表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_銷售備註表()
        ConnOpen()
        SQL1 = "SELECT 資料流水號, 資料流水號 AS 項次, 備註, 收入, 支出, 收支單號, 轉財務, 含稅 FROM 銷售備註表 WHERE (單號 LIKE '" & PA2 & "') ORDER BY 資料流水號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_銷售衍生費用()
        ConnOpen()
        SQL1 = "SELECT 資料流水號, 資料流水號  AS 項次, 單號, 運費備註, 支出, 收支單號, 轉財務, 含稅 FROM 銷售衍生運費 WHERE (單號 LIKE '" & PA2 & "') ORDER BY 資料流水號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_銷售單號串聯倉儲表取得倉儲單號()
        ConnOpen()
        SQL1 = "SELECT 倉儲明細表.執行單號 FROM 倉儲明細表 INNER JOIN 銷售明細表 ON 倉儲明細表.採購單號 = 銷售明細表.單號 WHERE (銷售明細表.單號 LIKE '" & PA & "') GROUP BY 倉儲明細表.執行單號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售備註表_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 銷售備註表 (資料流水號, 單號, 備註, 收入, 支出) VALUES (N'" & PA1 & "', '" & PA & "', '', N'0', N'0')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售衍生運費_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 銷售衍生運費 (資料流水號, 單號, 運費備註, 支出) VALUES (N'" & PA1 & "', '" & PA & "', '', N'0')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售收款事項_新增2()
        ConnOpen()
        SQL1 = "INSERT INTO 銷售收款事項 (資料流水號, 單號, 項次, 內容, 金額) VALUES (N'" & PA1 & "', '" & PA & "', '" & PA2 & "', N'', N'0')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售收款事項_新增3()
        ConnOpen()
        SQL1 = "INSERT INTO 銷售收款事項 (資料流水號, 單號, 項次, 內容, 金額) VALUES (N'" & PA1 & "', '" & PA & "', '0', N'刷卡', N'0')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售備註表_刪除()
        ConnOpen() : SQL1 = "DELETE 銷售備註表 WHERE 資料流水號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售衍生費用_刪除()
        ConnOpen() : SQL1 = "DELETE 銷售衍生運費 WHERE 資料流水號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售收款事項_刪除()
        ConnOpen() : SQL1 = "DELETE 銷售收款事項 WHERE 資料流水號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細表_確認單據是否申請()
        ConnOpen() : SQL1 = "SELECT 料號 FROM 銷售明細表 WHERE 單號 LIKE N'" & PA1 & "' AND 料號 LIKE N'" & PA2 & "' AND 訂製狀態 LIKE '" & PA8 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細表_排序()
        ConnOpen() : SQL1 = "SELECT TOP (1) 排序 FROM 銷售明細表 WHERE 單號 LIKE N'" & PA4 & "' ORDER BY 排序 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細表_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 資料流水號 FROM 銷售明細表 ORDER BY 資料流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售備註表_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 資料流水號 FROM 銷售備註表  ORDER BY 資料流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售衍生運費_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 資料流水號 FROM 銷售衍生運費 ORDER BY 資料流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售收款事項_最後一筆資料()
        ConnOpen() : SQL1 = "SELECT TOP (1) 資料流水號 FROM 銷售收款事項 ORDER BY 資料流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售收款事項_最後一筆項次()
        ConnOpen() : SQL1 = "SELECT TOP (1) 項次 FROM 銷售收款事項 WHERE 單號 LIKE '" & PA & "' ORDER BY 項次 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細_改倉名()
        ConnOpen() : SQL1 = "SELECT 倉名編號 FROM 倉儲分區控制表 WHERE 倉名 LIKE N'" & PA20 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細_改物料訂製狀態()
        ConnOpen() : SQL1 = "SELECT 編碼 FROM 物料訂製狀態 WHERE 訂製 LIKE N'" & PA19 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細_倉儲狀態()
        ConnOpen() : SQL1 = "SELECT 編碼 FROM 倉儲狀態 WHERE 狀態 LIKE N'" & PA18 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_盤盈盤損申請_單據()
        ConnOpen() : SQL1 = "SELECT 執行單號, 申請人, 申請日期 FROM 倉儲明細表 WHERE (狀態 LIKE N'盤%') AND (審核人 LIKE '') GROUP BY 執行單號, 申請人, 申請日期" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_盤盈盤損申請_倉儲明細表_盤盈入庫新增()
        ConnOpen()
        SQL1 = "INSERT INTO 倉儲明細表 (資料流水號, 執行單號, 倉級, 倉名編號, 料號, 入庫, 出庫, 備註, 狀態, 採購單號, 申請人, 申請日期, 審核人, 審核日期, 倉庫作業, 作業日期, 物料狀態, 訂製狀態) 
                VALUES (N'" & PA3 & "',N'" & PA4 & "',N'" & PA5 & "',N'" & PA6 & "',N'" & PA2 & "',N'" & NU1 & "', N'0', N'', N'盤盈入庫', N'', N'" & PA9 & "', 
                        N'" & DTP & "', N'', N'', N'', N'', N'" & PA7 & "', N'" & PA8 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_盤盈盤損申請_倉儲明細表_盤損出庫新增()
        ConnOpen()
        SQL1 = "INSERT INTO 倉儲明細表 (資料流水號, 執行單號, 倉級, 倉名編號, 料號, 入庫, 出庫, 備註, 狀態, 採購單號, 申請人, 申請日期, 審核人, 審核日期, 倉庫作業, 作業日期, 物料狀態, 訂製狀態) 
                VALUES (N'" & PA3 & "',N'" & PA4 & "',N'" & PA5 & "',N'" & PA6 & "',N'" & PA2 & "', N'0',N'" & NU2 & "', N'', N'盤損出庫', N'', N'" & PA9 & "', 
                        N'" & DTP & "', N'', N'', N'', N'', N'" & PA7 & "', N'" & PA8 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_盤盈盤損申請_明細()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.資料流水號, 供應商資料表.簡稱 AS 供應商, 倉儲分區控制表.倉名, 倉儲明細表.料號, 物料資料庫.品名, 物料訂製狀態.訂製, 倉儲狀態.狀態 AS 倉儲狀態, 
                            倉儲明細表.入庫 AS 盤盈, 倉儲明細表.出庫 AS 盤損, 倉儲明細表.狀態 AS 資料型態, 倉儲明細表.備註, 物料資料庫.是否有圖 AS 圖片
                FROM        倉儲明細表 INNER JOIN 倉儲分區控制表 ON 倉儲明細表.倉名編號 = 倉儲分區控制表.倉名編號 INNER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號 INNER JOIN
                            倉儲狀態 ON 倉儲明細表.物料狀態 = 倉儲狀態.編碼 INNER JOIN 物料訂製狀態 ON 倉儲明細表.訂製狀態 = 物料訂製狀態.編碼 INNER JOIN
                            供應商資料表 ON 物料資料庫.供應商編號 = 供應商資料表.編號
                WHERE      (倉儲明細表.執行單號 LIKE N'" & PA20 & "')
                ORDER BY    倉儲明細表.料號, 倉儲明細表.資料流水號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_送貨地點_下拉清單()
        ConnOpen() : SQL1 = "SELECT 地區, 起車, 最低售額 FROM 送貨起車參數 ORDER BY 起車" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_未過帳()
        ConnOpen()
        SQL1 = "SELECT      採購控制表.已過帳 AS 選擇, 採購控制表.資料流水號, 採購控制表.銷售單號, 採購控制表.供商編號, 供應商資料表.簡稱 AS 供應商, 採購控制表.料號, 物料資料庫.品名, 
                            採購控制表.倉儲狀態, 倉儲分區控制表.倉名 AS 倉名, 採購控制表.訂製狀態, 物料訂製狀態.訂製, 採購控制表.物料狀態, 倉儲狀態.狀態 AS 狀態, 採購控制表.備註, 
                            採購控制表.訂製圖號, 採購控制表.數量, 採購控制表.成本, 採購控制表.採購總價 AS 金額, 採購控制表.申請人, 採購控制表.申請日期, 採購控制表.採購日期, 
                            採購控制表.預計進廠日, 採購控制表.實際進廠日, 採購控制表.過帳日期, 採購控制表.已入庫, 採購控制表.已審核, 採購控制表.銷售流水
                FROM        採購控制表 INNER JOIN 供應商資料表 ON 採購控制表.供商編號 = 供應商資料表.編號 INNER JOIN 物料資料庫 ON 採購控制表.料號 = 物料資料庫.料號 INNER JOIN 倉儲狀態 ON 
                            採購控制表.物料狀態 = 倉儲狀態.編碼 INNER JOIN 物料訂製狀態 ON 採購控制表.訂製狀態 = 物料訂製狀態.編碼 INNER JOIN 倉儲分區控制表 ON 採購控制表.倉儲狀態 = 
                            倉儲分區控制表.倉名編號
                WHERE      ((採購控制表.已過帳 IS NULL) OR (採購控制表.已過帳 = 0)) AND (採購控制表.供商編號 LIKE N'%" & PA & "%' OR 供應商資料表.簡稱 LIKE N'%" & PA & "%') AND 
                           (採購控制表.銷售單號 LIKE N'" & PA20 & "%')
                ORDER BY    採購控制表.供商編號, 採購控制表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_已過帳()
        ConnOpen()
        SQL1 = "SELECT      採購控制表.已過帳 AS 選擇, 採購控制表.資料流水號, 採購控制表.銷售單號, 採購控制表.供商編號, 供應商資料表.簡稱 AS 供應商, 採購控制表.料號, 物料資料庫.品名, 
                            採購控制表.倉儲狀態, 倉儲分區控制表.倉名 AS 倉名, 採購控制表.訂製狀態, 物料訂製狀態.訂製, 採購控制表.物料狀態, 倉儲狀態.狀態 AS 狀態, 採購控制表.備註, 
                            採購控制表.訂製圖號, 採購控制表.數量, 採購控制表.成本, 採購控制表.採購總價 AS 金額, 採購控制表.申請人, 採購控制表.申請日期, 採購控制表.採購日期, 採購控制表.預計進廠日, 
                            採購控制表.實際進廠日, 採購控制表.過帳日期, 採購控制表.已入庫, 採購控制表.已審核, 採購控制表.銷售流水
                FROM        採購控制表 INNER JOIN 供應商資料表 ON 採購控制表.供商編號 = 供應商資料表.編號 INNER JOIN 物料資料庫 ON 採購控制表.料號 = 物料資料庫.料號 INNER JOIN 倉儲狀態 ON 
                            採購控制表.物料狀態 = 倉儲狀態.編碼 INNER JOIN 物料訂製狀態 ON 採購控制表.訂製狀態 = 物料訂製狀態.編碼 INNER JOIN 倉儲分區控制表 ON 採購控制表.倉儲狀態 = 
                            倉儲分區控制表.倉名編號
                WHERE      (採購控制表.已過帳 = 1) AND (採購控制表.供商編號 LIKE N'%" & PA & "%' OR 供應商資料表.簡稱 LIKE N'%" & PA & "%') AND 
                           (採購控制表.銷售單號 LIKE N'" & PA20 & "%')
                ORDER BY    採購控制表.供商編號, 採購控制表.過帳日期 DESC, 採購控制表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_未出庫()
        ConnOpen()
        SQL1 = "SELECT      採購控制表.資料流水號, 採購控制表.銷售單號, 採購控制表.供商編號, 供應商資料表.簡稱 AS 供應商, 採購控制表.料號, 物料資料庫.品名, 採購控制表.倉儲狀態, 
                            倉儲分區控制表.倉名 AS 倉名, 採購控制表.訂製狀態, 物料訂製狀態.訂製, 採購控制表.物料狀態, 倉儲狀態.狀態 AS 狀態, 採購控制表.備註, 
                            採購控制表.訂製圖號, 採購控制表.數量, 採購控制表.成本, 採購控制表.採購總價 AS 金額, 採購控制表.申請人, 採購控制表.申請日期, 採購控制表.採購日期, 採購控制表.預計進廠日, 
                            採購控制表.實際進廠日, 採購控制表.已入庫, 採購控制表.已審核
                FROM        採購控制表 INNER JOIN 供應商資料表 ON 採購控制表.供商編號 = 供應商資料表.編號 INNER JOIN 物料資料庫 ON 採購控制表.料號 = 物料資料庫.料號 INNER JOIN 倉儲狀態 ON 
                            採購控制表.物料狀態 = 倉儲狀態.編碼 INNER JOIN 物料訂製狀態 ON 採購控制表.訂製狀態 = 物料訂製狀態.編碼 INNER JOIN 倉儲分區控制表 ON 採購控制表.倉儲狀態 = 
                            倉儲分區控制表.倉名編號
                WHERE      ((採購控制表.已入庫 IS NULL) OR (採購控制表.已入庫 = 0)) AND (採購控制表.供商編號 LIKE N'%" & PA & "%' OR 供應商資料表.簡稱 LIKE N'%" & PA & "%') AND 
                           (採購控制表.銷售單號 LIKE N'" & PA20 & "%')
                ORDER BY    採購控制表.供商編號, 採購控制表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_一般採購_未出庫()
        ConnOpen()
        SQL1 = "SELECT      採購控制表.資料流水號, 採購控制表.銷售單號, 採購控制表.供商編號, 供應商資料表.簡稱 AS 供應商, 採購控制表.料號, 物料資料庫.品名, 採購控制表.倉儲狀態, 
                            倉儲分區控制表.倉名 AS 倉名, 採購控制表.訂製狀態, 物料訂製狀態.訂製, 採購控制表.物料狀態, 倉儲狀態.狀態 AS 狀態, 採購控制表.備註, 
                            採購控制表.訂製圖號, 採購控制表.數量, 採購控制表.成本, 採購控制表.採購總價 AS 金額, 採購控制表.申請人, 採購控制表.申請日期, 採購控制表.採購日期, 採購控制表.預計進廠日, 
                            採購控制表.實際進廠日, 採購控制表.已入庫, 採購控制表.已審核
                FROM        採購控制表 INNER JOIN 供應商資料表 ON 採購控制表.供商編號 = 供應商資料表.編號 INNER JOIN 物料資料庫 ON 採購控制表.料號 = 物料資料庫.料號 INNER JOIN 倉儲狀態 ON 
                            採購控制表.物料狀態 = 倉儲狀態.編碼 INNER JOIN 物料訂製狀態 ON 採購控制表.訂製狀態 = 物料訂製狀態.編碼 INNER JOIN 倉儲分區控制表 ON 採購控制表.倉儲狀態 = 
                            倉儲分區控制表.倉名編號
                WHERE      ((採購控制表.已入庫 IS NULL) OR (採購控制表.已入庫 = 0)) AND 
                           (採購控制表.供商編號 LIKE N'%" & PA & "%' OR 供應商資料表.簡稱 LIKE N'%" & PA & "%' OR 
                            物料資料庫.品名 LIKE N'%" & PA & "%' OR 採購控制表.料號  LIKE N'%" & PA & "%') AND 
                           (採購控制表.銷售單號 LIKE N'" & PA20 & "%') AND (採購控制表.已審核 <> 1)
                ORDER BY    採購控制表.供商編號, 採購控制表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_一般採購_已出庫()
        ConnOpen()
        SQL1 = "SELECT      採購控制表.資料流水號, 採購控制表.銷售單號, 採購控制表.供商編號, 供應商資料表.簡稱 AS 供應商, 採購控制表.料號, 物料資料庫.品名, 採購控制表.倉儲狀態, 
                            倉儲分區控制表.倉名 AS 倉名, 採購控制表.訂製狀態, 物料訂製狀態.訂製, 採購控制表.物料狀態, 倉儲狀態.狀態 AS 狀態, 採購控制表.備註, 
                            採購控制表.訂製圖號, 採購控制表.數量, 採購控制表.成本, 採購控制表.採購總價 AS 金額, 採購控制表.申請人, 採購控制表.申請日期, 採購控制表.採購日期, 採購控制表.預計進廠日, 
                            採購控制表.實際進廠日, 採購控制表.已入庫, 採購控制表.已審核
                FROM        採購控制表 INNER JOIN 供應商資料表 ON 採購控制表.供商編號 = 供應商資料表.編號 INNER JOIN 物料資料庫 ON 採購控制表.料號 = 物料資料庫.料號 INNER JOIN 倉儲狀態 ON 
                            採購控制表.物料狀態 = 倉儲狀態.編碼 INNER JOIN 物料訂製狀態 ON 採購控制表.訂製狀態 = 物料訂製狀態.編碼 INNER JOIN 倉儲分區控制表 ON 採購控制表.倉儲狀態 = 
                            倉儲分區控制表.倉名編號
                WHERE      ((採購控制表.已入庫 IS NULL) OR (採購控制表.已入庫 = 0)) AND 
                           (採購控制表.供商編號 LIKE N'%" & PA & "%' OR 供應商資料表.簡稱 LIKE N'%" & PA & "%' OR 
                            物料資料庫.品名 LIKE N'%" & PA & "%' OR 採購控制表.料號  LIKE N'%" & PA & "%') AND 
                           (採購控制表.銷售單號 LIKE N'" & PA20 & "%') AND (採購控制表.已審核 = 1)
                ORDER BY    採購控制表.供商編號, 採購控制表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_驗證()
        ConnOpen()
        SQL1 = "SELECT      採購控制表.資料流水號, 採購控制表.銷售單號, 採購控制表.供商編號, 供應商資料表.簡稱 AS 供應商, 採購控制表.料號, 物料資料庫.品名, 採購控制表.倉儲狀態, 
                            倉儲分區控制表.倉名 AS 倉名, 採購控制表.訂製狀態, 物料訂製狀態.訂製, 採購控制表.物料狀態, 倉儲狀態.狀態 AS 狀態, 採購控制表.備註, 
                            採購控制表.訂製圖號, 採購控制表.數量, 採購控制表.成本, 採購控制表.採購總價 AS 金額, 採購控制表.申請人, 採購控制表.申請日期, 採購控制表.採購日期, 採購控制表.預計進廠日, 
                            採購控制表.實際進廠日, 採購控制表.已入庫, 採購控制表.已審核
                FROM        採購控制表 INNER JOIN 供應商資料表 ON 採購控制表.供商編號 = 供應商資料表.編號 INNER JOIN 物料資料庫 ON 採購控制表.料號 = 物料資料庫.料號 INNER JOIN 倉儲狀態 ON 
                            採購控制表.物料狀態 = 倉儲狀態.編碼 INNER JOIN 物料訂製狀態 ON 採購控制表.訂製狀態 = 物料訂製狀態.編碼 INNER JOIN 倉儲分區控制表 ON 採購控制表.倉儲狀態 = 
                            倉儲分區控制表.倉名編號
                WHERE      ((採購控制表.已審核 IS NULL) OR (採購控制表.已審核 = 0)) AND (採購控制表.供商編號 LIKE N'" & PA & "%' OR 供應商資料表.簡稱 LIKE N'%" & PA & "%') AND 
                           (採購控制表.銷售單號 LIKE N'" & PA20 & "%')
                ORDER BY    採購控制表.供商編號, 採購控制表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 採購控制表 (資料流水號, 銷售單號, 供商編號, 料號, 物料狀態, 訂製狀態, 倉儲狀態, 備註, 數量,  成本, 採購總價, 申請人, 申請日期, 
                                        採購日期, 預計進廠日, 實際進廠日, 已入庫, 已審核, 銷售流水) 
                                VALUES (N'" & PA1 & "',N'" & PA2 & "',N'" & PA3 & "',N'" & PA4 & "',N'" & PA5 & "', N'" & PA6 & "',N'" & PA7 & "', N'" & PA8 & "', N'" & NU1 & "', N'" & NU2 & "', 
                                        N'" & NU3 & "', N'" & PA9 & "', N'" & PA10 & "', N'" & PA11 & "', N'" & PA12 & "', '', '0', '" & BL1 & "', '" & PA13 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_修改()
        ConnOpen()
        SQL1 = "UPDATE 採購控制表 SET 訂製圖號 = N'" & PA3 & "' WHERE 資料流水號 LIKE '" & PA1 & "%'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售控制表_驗證跳過()
        ConnOpen() : SQL1 = "UPDATE 銷售控制表 SET 已驗證 = N'1' WHERE 單號 LIKE '" & PA & "%'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售控制表_驗證解除()
        ConnOpen() : SQL1 = "UPDATE 銷售控制表 SET 已驗證 = N'0' WHERE 單號 LIKE '" & PA & "%'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售控制表_轉採購修改()
        ConnOpen() : SQL1 = "UPDATE 銷售控制表 SET 轉採購 = N'1' WHERE 單號 LIKE '" & PA & "%'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售控制表_轉採購返回()
        ConnOpen() : SQL1 = "UPDATE 銷售控制表 SET 轉採購 = N'0' WHERE 單號 LIKE '" & PA & "%'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細_出貨返回()
        ConnOpen() : SQL1 = "UPDATE 銷售明細表 SET 已出貨 = N'0' WHERE 單號 LIKE '" & PA & "%'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售明細_出貨返回_單筆()
        ConnOpen() : SQL1 = "UPDATE 銷售明細表 SET 已出貨 = N'0' WHERE 單號 LIKE '" & PA & "%' AND 料號 LIKE '" & PA1 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售控制表_出貨返回()
        ConnOpen() : SQL1 = "UPDATE 銷售控制表 SET 已出貨 = N'0' WHERE 單號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_銷售控制表_出貨修改()
        ConnOpen() : SQL1 = "UPDATE 銷售控制表 SET 已出貨 = N'1' WHERE 單號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_刪除()
        ConnOpen() : SQL1 = "DELETE 採購控制表 WHERE (資料流水號 = N'" & PA & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_訂製圖檔清單()
        ConnOpen()
        SQL1 = "SELECT 資料流水號, 單號, 版次 FROM 採購訂製圖庫 WHERE (資料流水號 LIKE '" & PA15 & "')"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_外埔報表()
        ConnOpen()
        SQL1 = "SELECT      採購外埔表.銷售單號, 供應商資料表.簡稱 AS 供應商, 採購外埔表.備註內容, 採購外埔表.金額, 採購外埔表.過帳日期, 
                            採購外埔表.流水號, 採購外埔表.廠商編碼
                FROM        採購外埔表 INNER JOIN 供應商資料表 ON 採購外埔表.廠商編碼 = 供應商資料表.編號
                WHERE      (採購外埔表.過帳日期 LIKE '') AND (採購外埔表.廠商編碼 LIKE  '%" & PA & "%') ORDER BY 過帳日期 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_外埔報表_已過()
        ConnOpen()
        SQL1 = "SELECT      採購外埔表.銷售單號, 供應商資料表.簡稱 AS 供應商, 採購外埔表.備註內容, 採購外埔表.金額, 採購外埔表.過帳日期, 
                            採購外埔表.流水號, 採購外埔表.廠商編碼
                FROM        採購外埔表 INNER JOIN 供應商資料表 ON 採購外埔表.廠商編碼 = 供應商資料表.編號
                WHERE      (採購外埔表.過帳日期 NOT LIKE '') AND (採購外埔表.廠商編碼 LIKE  '%" & PA & "%') ORDER BY 過帳日期 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_應負帳款_外埔報表()
        ConnOpen()
        SQL1 = "SELECT      採購外埔表.銷售單號, 供應商資料表.簡稱 AS 供應商, 採購外埔表.備註內容, 採購外埔表.金額, 採購外埔表.過帳日期, 
                            採購外埔表.流水號, 採購外埔表.廠商編碼
                FROM        採購外埔表 INNER JOIN
                            供應商資料表 ON 採購外埔表.廠商編碼 = 供應商資料表.編號
                WHERE      (採購外埔表.過帳日期 BETWEEN '" & Format(採購應付帳款.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(採購應付帳款.結束日期_dtp.Value, "yyyy/MM/dd") & "')"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_供應商_下拉清單()
        ConnOpen() : SQL1 = "SELECT  編號, 簡稱 FROM   供應商資料表 ORDER BY   編號" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_圖片新增()
        ConnOpen()
        SQL1 = "INSERT INTO 採購訂製圖庫 (資料流水號, 單號, 版次, 圖片) SELECT N'" & PA1 & "',N'" & PA2 & "',
                N'" & PA3 & "',BULKCOLUMN FROM OPENROWSET ( BULK '" & FTP物理位置 & AA(1) & "\" & PA4 & "', SINGLE_BLOB) AS EMPLOYEEPICTURE"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_訂製圖片()
        ConnOpen() : SQL1 = "SELECT 圖片 FROM 採購訂製圖庫 WHERE (資料流水號 LIKE '" & PA15 & "') AND (版次 LIKE '" & PA16 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_訂製圖片下載()
        ConnOpen() : SQL1 = "SELECT 圖片 FROM 採購訂製圖庫 WHERE (資料流水號 LIKE '" & PA15 & "') AND (版次 LIKE '" & PA16 & "')" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_採購控制表_存檔()
        ConnOpen() : SQL1 = "UPDATE 採購控制表 SET 銷售流水 = '' WHERE (銷售單號 LIKE '') AND (銷售流水 NOT LIKE '')" : CmdSet_For_dr()
        ConnOpen()
        SQL1 = "UPDATE 採購控制表 SET 物料狀態 = N'" & PA1 & "', 訂製狀態 = N'" & PA2 & "', 倉儲狀態 = N'" & PA3 & "', 備註 = N'" & PA4 & "', 數量 = '" & NU1 & "',
                                      成本 = '" & NU2 & "', 採購總價 = '" & NU3 & "', 採購日期 = N'" & PA5 & "', 預計進廠日 = N'" & PA6 & "', 實際進廠日 = N'" & PA7 & "'
                WHERE 資料流水號 LIKE '" & PA & "%'"
        CmdSet_For_dr()
        ConnOpen()
        SQL1 = "UPDATE 銷售明細表 SET 成本 = N'" & NU2 & "',倉儲狀態 = N'" & PA3 & "', 物料狀態 = N'" & PA1 & "', 訂製狀態 = N'" & PA2 & "' 
                WHERE (資料流水號 LIKE N'" & PA8 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_存檔1()
        ConnOpen() : SQL1 = "UPDATE 採購控制表 SET 銷售流水 = '' WHERE (銷售單號 LIKE '') AND (銷售流水 NOT LIKE '')" : CmdSet_For_dr()
        ConnOpen()
        SQL1 = "UPDATE 採購控制表 SET 數量 = '" & NU1 & "', 成本 = '" & NU2 & "', 採購總價 = '" & NU3 & "', 過帳日期 = '" & PA1 & "' WHERE 資料流水號 LIKE '" & PA & "%'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_存檔2()
        ConnOpen()
        SQL1 = "UPDATE 採購控制表 SET 物料狀態 = N'" & PA1 & "', 訂製狀態 = N'" & PA2 & "', 倉儲狀態 = N'" & PA3 & "', 備註 = N'" & PA4 & "', 數量 = '" & NU1 & "',
                                      成本 = '" & NU2 & "', 採購總價 = '" & NU3 & "', 採購日期 = N'" & PA5 & "', 預計進廠日 = N'" & PA7 & "', 實際進廠日 = N'" & PA35 & "' 
                WHERE 資料流水號 LIKE '" & PA & "%'"
        CmdSet_For_dr()
        ConnOpen()
        SQL1 = "UPDATE 銷售明細表 SET 成本 = N'" & NU2 & "',倉儲狀態 = N'" & PA3 & "', 物料狀態 = N'" & PA1 & "', 訂製狀態 = N'" & PA2 & "' 
                WHERE (資料流水號 LIKE N'" & PA8 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_過帳()
        ConnOpen()
        SQL1 = "UPDATE 採購控制表 SET 已過帳 = '" & PA2 & "', 過帳日期 = N'" & PA1 & "' WHERE 資料流水號 LIKE '" & PA & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_帳號讀取()
        ConnOpen() : SQL1 = "SELECT 帳號, 姓名 FROM 使用者權限管理表" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_採購控制表_審核通過()
        ConnOpen() : SQL1 = "UPDATE 採購控制表 SET 已審核 = N'" & BL1 & "' WHERE 資料流水號 LIKE '" & PA & "%'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_開單狀態()
        ConnOpen()
        SQL1 = "SELECT TOP (1) 單號, 開單日期 FROM 銷售控制表 WHERE (LEFT(單號, 1) LIKE '" & YD_ERP_SYS.業務_cb.Text & "') 
                ORDER BY   CHARINDEX(LEFT(單號, 1), '123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'), 單號 DESC"
        CmdSet_For_DGV()
    End Sub
End Module
